#ifndef __AD9833_HPP
#define __AD9833_HPP

#include "..\lpcOpenInclude\board.h"
#include "Spi.hpp"
#include "Monitor.hpp"
#include "Monitorbef.hpp"
#include "Pin.hpp"

class  CAD9833: public CMonitorBef
{
public:
	enum enumWave
	{
		WAVE_NOCHANGE = 0,  
		WAVE_SINUS,  
		WAVE_SQUARE,
		WAVE_TRIANGLE,
		INIT_WAVE = 33,  // nur fr Init. Zwecke
	};
		
protected:
	CSpi			*m_pSpiBus;
	enumWave	m_LastWave;
	uint16_t  m_WaveRegBits;
	uint32_t	m_InputFrequenz;
	CPinOut		*m_pCSPort;
	bool			m_bFreqReg1;
	bool WriteReg( uint16_t *Reg, uint8_t Count );
	bool SetWaveReg( enumWave Wave, uint16_t &Reg );
public:
	// SSP_CS wird genommen, d.h. Controller steuert CS-Signal direkt
	CAD9833( CSpi *SpiBus, uint32_t InputFrequenz, CPinOut *pCSPort, char * Text, unsigned int Len, CMonitor *pMonitor );
	bool Frequenz( uint32_t Frequenz );
	bool Phase( uint16_t Phase );
	bool Signalform( enumWave Wave );
	bool Init( );
	bool Reset( );

	virtual bool Work( char *Text, unsigned int &Len );
	virtual void ShortHelp();
	virtual void LongHelp();

};
 #endif 
